#!/bin/sh
#

# hier is full path to install.img
img=$1 

# hier is path only
path=${img%/*} 

log="$img.0.beforeinstallscript.log"
macfile="$path/mac.txt"
gbitfile="$path/gbit.txt"
if [ ! -e "$log" ]; then
	touch "$log"
	if [ ! -e "$macfile" ]; then
		echo "MOS: before install script"
		# read mac address
		echo -en "MOS: "
		dmesg| grep -i 'mac address:'
		echo -en "mac=" > "$macfile"
		dmesg| grep -i 'mac address:'|grep -io '[0-9A-F]\{2\}\([.:][0-9A-F]\{2\}\)\{5\}' >> "$macfile"
		echo "MOS: MAC-Address is saved into mac.txt" >> "$log"
		echo "MOS: Network HW ID" >> "$log"
		/bin/gpio -n:p 0xb801605C 0x04030000  >> "$log"
		/bin/gpio -n:p 0xb801605C >> "$log"
		/bin/gpio -n:p 0xb801605C 0x04030000;/bin/gpio -n:p 0xb801605C|grep -q "0x8403C914"&&touch "$gbitfile"
		/bin/gpio -n:p 0xb801605C 0x04030000;/bin/gpio -n:p 0xb801605C|grep -q "0x8403C915"&&touch "$gbitfile"
		if [ -e "$gbitfile" ]; then
			echo "MOS: Gbit detected"
			echo "MOS: Gbit detected" >> "$log"
		fi
		# save dmesg into log
		echo "MOS: dmesg before script" >> "$log"
		dmesg -c >> "$log"
		sync
	else
		echo "MOS: file mac.txt exists"
		echo "MOS: file mac.txt exists" >> "$log"
	fi
fi

log="$img.1.flash_erase.log"
if [ ! -e "$log" ]; then
	touch "$log"
	echo "MOS: flash_erase"  
	echo "MOS: system messages" >> "$log"
	dmesg -c >> "$log"
	sync
	tar -xf "$img" flash_erase -C /tmp/ >> "$log" 2>&1
	chmod +x /tmp/flash_erase
	echo "MOS: execute flash_erase 1" >> "$log"
	/tmp/flash_erase /dev/mtd0 0 64 >> "$log" 2>&1
	echo "MOS: execute flash_erase 2" >> "$log"
	/tmp/flash_erase /dev/mtd0 0 2048 >> "$log" 2>&1
	tar -xf "$img" flash_eraseall -C /tmp/ >> "$log" 2>&1
	chmod +x /tmp/flash_eraseall
	echo "MOS: execute flash_eraseall" >> "$log"
	/tmp/flash_eraseall /dev/mtd0 >> "$log" 2>&1
	echo "MOS: system messages after flash_eraseall" >> "$log"
	dmesg -c >> "$log"
	tar -xf "$img" reload_bbt -C /tmp/ >> "$log" 2>&1
	chmod +x /tmp/reload_bbt
	echo "MOS: execute reload_bbt" >> "$log"
	/tmp/reload_bbt /dev/mtd0 >> "$log" 2>&1
	sync
	echo "MOS: system messages after reload_bbt" >> "$log"
	dmesg -c >> "$log"
	echo "MOS: reboot" >> "$log"
	sync
	
	sleep 5
	for i in /tmp/usbmounts/* ; do umount $i ; done
	sleep 5
	
	reboot
else	
	log="$img.2.install_a.log"
	if [ ! -e "$log" ]; then
		touch "$log"
		echo "MOS: install boot"  
		echo "MOS: system messages" >> "$log"
		dmesg -c >> "$log"
		sync
		echo "MOS: extract install_a1" >> "$log"
		tar -xf "$img" install_a1 -C /tmp/ >> "$log" 2>&1
		chmod +x /tmp/install_a1
		echo "MOS: execute install_a1" >> "$log"
		sync
		/tmp/install_a1 "$1" >> "$log" 2>&1
		sync
		echo "MOS: install_a1 finished" >> "$log"
		sync
		sleep 3  
		sync
		reboot
	else 	
		step3="0"
		log="$img.3.afterinstallscript.log"
		if [ -e "$macfile" ]; then
			if [ ! -e "$log" ]; then
				touch "$log"
				echo "MOS: dmesg" >> "$log"
				dmesg -c >> "$log"
				bcs=31457280
				cat /sys/realtek_boards/system_parameters|grep -q "nand_boot_size=c00000"&&bcs=12582912
				cat /sys/realtek_boards/system_parameters|grep -q "nand_boot_size=3200000"&&bcs=52428800
				echo "MOS: write script address $bcs"
				echo "MOS: write script address $bcs" >> "$log"
				. "$path/mac.txt"
				echo "MOS: command for boot shell"
				echo "MOS: command for boot shell" >> "$log"
				if [ -e "$gbitfile" ]; then
					echo "setenv Gbit;setenv ethaddr $mac;saveenv;factory -c \n\0\0"
					echo "setenv Gbit;setenv ethaddr $mac;saveenv;factory -c \n\0\0" >> "$log"
					echo -en "setenv Gbit;setenv ethaddr $mac;saveenv;factory -c \n\0\0"|dd bs=1 count=512 seek=$bcs of=/dev/mtdblock0
				else
					echo "setenv ethaddr $mac;saveenv;factory -c \n\0\0"
					echo "setenv ethaddr $mac;saveenv;factory -c \n\0\0" >> "$log"
					echo -en "setenv ethaddr $mac;saveenv;factory -c \n\0\0"|dd bs=1 count=512 seek=$bcs of=/dev/mtdblock0
				fi
				echo "MOS: dmesg after mac script" >> "$log"
				dmesg -c >> "$log"
				echo "MOS: do reboot step 3"
				sync
				step3="1"
				sleep 5
				for i in /tmp/usbmounts/* ; do umount $i ; done
				sleep 5
				reboot
			fi
		else
			echo "MOS: no mac file"
			echo "MOS: no mac file" > "$log"
			sync
		fi
		if [ $step3 == "0" ]; then
			log="$img.4.last_step.log"
			if [ ! -e "$log" ]; then
				touch "$log"
				echo "MOS: last step"  
				echo "MOS: last step" >> "$log"
				busybox dmesg -c >> "$log"
				sync
				echo "MOS: cat /proc/cpuinfo" >> "$log"
				busybox cat /proc/cpuinfo >> "$log"
				echo "MOS: cat /proc/meminfo" >> "$log"
				busybox cat /proc/meminfo >> "$log"
				echo "MOS: df" >> "$log"
				busybox df -h >> "$log"
				echo "MOS: fdisk" >> "$log"
				busybox fdisk -l >> "$log"
				echo "MOS: ifconfig" >> "$log"
				busybox ifconfig >> "$log"
				sync		
			fi
		else
			echo "MOS: step 3 - wait reboot"
		fi
	fi
fi
